JazzSSParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
JazzSSParser Class Referencefinal

the main class to read a Jazz spreadsheet v1 (Lotus) document and some databases. More...

`#include <JazzSSParser.hxx>`

Inheritance diagram for JazzSSParser:

## Public Member Functions
| JazzSSParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~JazzSSParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| the main parse function More...
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | sendSpreadsheet ()
| sends the spreadsheet More...
bool | readZone11 (long endPos)
| reads a query/name/range... data (zone 11) More...
bool | readCell (int id, long endPos)
| reads a cell content data More...
bool | readSheetSize (long endPos)
| reads sheet size More...
bool | readDocument (long endPos)
| read the basic document zones (zone 15): selection, columns' width, default font, preferences... More...
bool | readCell (MWAWVec2i actPos, MWAWCellContent::FormulaInstruction &instr)
bool | readFormula (long endPos, MWAWVec2i const &pos, std::vector< MWAWCellContent::FormulaInstruction > &formula, std::string &error)
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< JazzSSParserInternal::State > | m_state
| the state More...

## Friends
class | JazzSSParserInternal::SubDocument

## Detailed Description

the main class to read a Jazz spreadsheet v1 (Lotus) document and some databases.

Note
  need more files to be sure to treat all documents
  a database is stored as a spreadsheet in the form [A][B] [C][empty] where [B] corresponds to the report's definitions and [C] corresponds to the database's contents

## Constructor & Destructor Documentation

## ◆ JazzSSParser()

JazzSSParser::JazzSSParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~JazzSSParser()

JazzSSParser::~JazzSSParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool JazzSSParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void JazzSSParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool JazzSSParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ parse()

void JazzSSParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| finalvirtual

the main parse function

Implements MWAWSpreadsheetParser.

## ◆ readCell() [1/2]

bool JazzSSParser::readCell | ( | int | id,
|  | long | endPos
| ) |  |
| protected

reads a cell content data

Referenced by createZones(), and readFormula().

## ◆ readCell() [2/2]

bool JazzSSParser::readCell | ( | MWAWVec2i | actPos,
|  | MWAWCellContent::FormulaInstruction & | instr
| ) |  |
| protected

## ◆ readDocument()

bool JazzSSParser::readDocument | ( | long | endPos | ) |
| protected

read the basic document zones (zone 15): selection, columns' width, default font, preferences...

Referenced by createZones().

## ◆ readFormula()

bool JazzSSParser::readFormula | ( | long | endPos,
|  | MWAWVec2i const & | pos,
|  | std::vector< MWAWCellContent::FormulaInstruction > & | formula,
|  | std::string & | error
| ) |  |
| protected

Referenced by readCell().

## ◆ readSheetSize()

bool JazzSSParser::readSheetSize | ( | long | endPos | ) |
| protected

reads sheet size

Referenced by createZones().

## ◆ readZone11()

bool JazzSSParser::readZone11 | ( | long | endPos | ) |
| protected

reads a query/name/range... data (zone 11)

Referenced by createZones().

## ◆ sendSpreadsheet()

bool JazzSSParser::sendSpreadsheet | ( |  | ) |
| protected

sends the spreadsheet

Referenced by parse().

## Friends And Related Function Documentation

## ◆ JazzSSParserInternal::SubDocument

friend class JazzSSParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<JazzSSParserInternal::State> JazzSSParser::m_state
| protected

the state

Referenced by checkHeader(), createZones(), readCell(), readDocument(), readSheetSize(), and sendSpreadsheet().

The documentation for this class was generated from the following files:

- JazzSSParser.hxx
- JazzSSParser.cxx